(*************************************************************
 *              Auto-assemblage de graphes                   *
 *************************************************************
   Auteur  : Fabien TARISSAN
   Fichier : system.ml
   Date    : 09/06/04
 *************************************************************
   Description : Syntaxe abstraite pour le systme
 *************************************************************)

open Agent;;
open Assembly;;
 
(* Ce que peut faire un systme pour voluer *)
type choice = BinJoin | UnJoin | Upd | Switch | Break
;;


(* Un systme est control par six paramtres *)
type system = {
  mutable active  : agent list; (* agents actifs  *) 
  mutable update  : agent list; (* agents en phase de mise 
				   jour *)
  mutable passive : agent list; (* agents en mode passif *) 
  mutable break   : agent list; (* agents en mode alarme *) 
  mutable final   : agent list; (* agents ayant atteint une
				   formation stable *)

  assembly : assembly           (* scnario de construction *)
}
;;



(* Choix alatoire de la prochaine action *)
let choose_attempt () =
  let n = Random.int 5 in
    if n=0 then UnJoin
    else if n = 1 then BinJoin
    else if n = 2 then Upd
    else if n = 3 then Switch
    else Break
;;

